<template>
  <div class="app-container">
    <el-form v-show="showSearch" ref="queryForm" :inline="true" :model="queryParams" label-width="68px" size="small">
      <el-form-item label="位号" prop="devNo">
        <el-input
          v-model="queryParams.devNo"
          clearable
          placeholder="请输入位号"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="位置" prop="position">
        <el-input
          v-model="queryParams.position"
          clearable
          placeholder="请输入位置"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="月份" prop="month">
        <el-date-picker
          v-model="month"
          :clearable="false"
          format="MM"
          placeholder="选择月"
          popper-class="picker-date"
          type="month"
          @change="handleQuery">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="年度" prop="year">
        <el-date-picker
          v-model="year"
          :clearable="false"
          format="yyyy"
          placeholder="请选择年份"
          type="year"
          @change="handleQuery">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="计划名称" prop="planId">
        <el-select v-model="queryParams.planId" clearable
                   @change="handleQuery">
          <el-option v-for="item in planList"
                     :key="item.id"
                     :label="item.planName"
                     :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button icon="el-icon-search" size="mini" type="primary" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!--      <el-col :span="1.5">
              <el-button
                type="primary"
                plain
                icon="el-icon-plus"
                size="mini"
                @click="handleAdd"
                v-hasPermi="['fire:cannon:add']"
              >新增</el-button>
            </el-col>
            <el-col :span="1.5">
              <el-button
                type="success"
                plain
                icon="el-icon-edit"
                size="mini"
                :disabled="single"
                @click="handleUpdate"
                v-hasPermi="['fire:cannon:edit']"
              >修改</el-button>
            </el-col>
            <el-col :span="1.5">
              <el-button
                type="danger"
                plain
                icon="el-icon-delete"
                size="mini"
                :disabled="multiple"
                @click="handleDelete"
                v-hasPermi="['fire:cannon:remove']"
              >删除</el-button>
            </el-col>-->
      <el-col :span="1.5">
        <el-button
          v-hasPermi="['fire:cannon:export']"
          icon="el-icon-download"
          plain
          size="mini"
          type="warning"
          @click="handleExport"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="cannonList" :height="clientHeight" border
              @selection-change="handleSelectionChange">
      <el-table-column align="center" type="selection" width="55"/>
      <el-table-column align="center" label="位号" prop="devNo"/>
      <el-table-column align="center" label="位置" prop="position"/>
      <el-table-column align="center" label="炮头转动" prop="headRotation">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.headRotation"/>
        </template>
      </el-table-column>
      <el-table-column align="center" label="阀门开关" prop="valveSwitch">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.valveSwitch"/>
        </template>
      </el-table-column>
      <el-table-column align="center" label="直流喷射" prop="dcInjection">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.dcInjection"/>
        </template>
      </el-table-column>
      <el-table-column align="center" label="旋转喷雾" prop="rotatingSpray">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.rotatingSpray"/>
        </template>
      </el-table-column>
      <el-table-column align="center" label="消防水炮出水压力" prop="outletPressure">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.outletPressure"/>
        </template>
      </el-table-column>
      <el-table-column align="center" label="确认人" prop="confirmed"/>
      <el-table-column align="center" label="备注" prop="remarks"/>
      <el-table-column align="center" class-name="small-padding fixed-width" label="操作">
        <template slot-scope="scope">
          <el-button
            icon="el-icon-picture-outline"
            size="mini"
            type="text"
            @click="openFileDialog(scope.row)"
          >附件
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :limit.sync="queryParams.pageSize"
      :page.sync="queryParams.pageNum"
      :total="total"
      @pagination="getList"
    />

    <!-- 添加或修改消防水炮检查记录对话框 -->
    <el-dialog :close-on-click-modal="false":title="title" :visible.sync="open" append-to-body width="500px">
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="位号" prop="devNo">
          <el-input v-model="form.devNo" placeholder="请输入位号"/>
        </el-form-item>
        <el-form-item label="位置" prop="position">
          <el-input v-model="form.position" placeholder="请输入位置"/>
        </el-form-item>
        <el-form-item label="炮头转动" prop="headRotation">
          <el-input v-model="form.headRotation" placeholder="请输入炮头转动"/>
        </el-form-item>
        <el-form-item label="阀门开关" prop="valveSwitch">
          <el-input v-model="form.valveSwitch" placeholder="请输入阀门开关"/>
        </el-form-item>
        <el-form-item label="直流喷射" prop="dcInjection">
          <el-input v-model="form.dcInjection" placeholder="请输入直流喷射"/>
        </el-form-item>
        <el-form-item label="旋转喷雾" prop="rotatingSpray">
          <el-input v-model="form.rotatingSpray" placeholder="请输入旋转喷雾"/>
        </el-form-item>
        <el-form-item label="消防水炮出水压力" prop="outletPressure">
          <el-input v-model="form.outletPressure" placeholder="请输入消防水炮出水压力"/>
        </el-form-item>
        <el-form-item label="备注" prop="remarks">
          <el-input v-model="form.remarks" placeholder="请输入备注"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>


    <el-dialog :close-on-click-modal="false":visible.sync="file.open" append-to-body title="附件详情" width="50%">
      <el-tabs v-model="tabName" :stretch="true" type="border-card">
        <el-tab-pane label="常规附件" name="a">
          <el-empty v-if="file.files.length==0" description="如你所见，这里什么都没有"></el-empty>
          <el-image v-for="url in file.files" v-else :key="url" :src="url"></el-image>
        </el-tab-pane>
        <el-tab-pane label="异常附件" name="b">
          <el-empty v-if="file.issuesFiles.length==0" description="如你所见，这里什么都没有"></el-empty>
          <el-image v-for="url in file.issuesFiles" v-else :key="url" :src="url"></el-image>
        </el-tab-pane>
        <el-tab-pane label="异常整改后附件" name="c">
          <el-empty v-if="file.repairFile.length==0" description="如你所见，这里什么都没有"></el-empty>
          <el-image v-for="url in file.repairFile" v-else :key="url" :src="url"></el-image>
        </el-tab-pane>
      </el-tabs>
    </el-dialog>
  </div>
</template>

<script>
import {addCannon, delCannon, getCannon, listCannon, updateCannon} from "@/api/patrol/fire/cannon";
import {listAllPlan} from "@/api/patrol/patrol/plan";

export default {
  dicts: ['inspection_status'],
  name: "Cannon",
  data() {
    return {
      tabName: 'a',
      planList: [],
      file: {
        open: false,
        issuesFiles: [],
        repairFile: [],
        files: []
      },
      month: new Date(),
      year: new Date(),
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 页面高度
      clientHeight: 300,
      // 总条数
      total: 0,
      // 消防水炮检查记录表格数据
      cannonList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        devNo: null,
        position: null,
        headRotation: null,
        valveSwitch: null,
        dcInjection: null,
        rotatingSpray: null,
        outletPressure: null,
        confirmed: null,
        checkStatus: null,
        checkDate: null,
        month: null,
        year: null,
        remarks: null,
        planId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        delFlag: [
          {required: true, message: "删除标识0未删除不能为空", trigger: "blur"}
        ],
      }
    };
  },
  created() {
    if (this.$route.query.year && this.$route.query.month) {
      this.year.setFullYear(this.$route.query.year, this.$route.query.month, 1);
      this.month.setMonth(this.$route.query.month, 1);
    }
    if (this.$route.query.planId) {
      this.queryParams.planId = parseInt(this.$route.query.planId)
    }
    if (this.$route.query.id) {
      this.queryParams.id = parseInt(this.$route.query.id)
      this.queryParams.issuesFlag = '1';
    }
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 270
    });

    if (!this.queryParams.id) {
      let query = {planQuarter: this.month.getMonth() + 1, planYear: this.year.getFullYear(), patrolType: '2'}
      listAllPlan(query).then(res => {
        this.planList = res.data;
        if (res.data.length > 0) {
          this.queryParams.planId = res.data[0].id;
        }
        this.getList();
      })
    }else{
      this.getList();
    }
  },
  methods: {
    openFileDialog(row) {
      this.tabName = 'a'
      this.file.issuesFiles = []
      this.file.files = []
      this.file.repairFile = []
      this.file.open = true;
      if (row.problemFileUrl)
        this.file.issuesFiles = row.problemFileUrl.split(',');
      if (row.fileUrl)
        this.file.files = row.fileUrl.split(',');
      if (row.repairFile)
        this.file.repairFile = row.repairFile.split(',');
    },
    getPlanList() {
      let query = {planQuarter: this.month.getMonth() + 1, planYear: this.year.getFullYear(), patrolType: '2'}
      listAllPlan(query).then(res => {
        this.planList = res.data;
      })
    },
    /** 查询消防水炮检查记录列表 */
    getList() {
      this.loading = true;
      if (!this.queryParams.id) {
        this.queryParams.month = this.month.getMonth() + 1;
        this.queryParams.year = this.year.getFullYear();
      }
      listCannon(this.queryParams).then(response => {
        this.cannonList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        devNo: null,
        position: null,
        headRotation: null,
        valveSwitch: null,
        dcInjection: null,
        rotatingSpray: null,
        outletPressure: null,
        confirmed: null,
        checkStatus: null,
        checkDate: null,
        month: null,
        year: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        remarks: null,
        deptId: null,
        planId: null,
        problemFileUrl: null,
        fileUrl: null,
        issuesStatus: null,
        issuesFlag: null,
        repairFile: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
      this.getPlanList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加消防水炮检查记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getCannon(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改消防水炮检查记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateCannon(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addCannon(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除消防水炮检查记录编号为"' + ids + '"的数据项？').then(function () {
        return delCannon(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download2('fire/cannon/export', {
        ...this.queryParams
      }, `cannon_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
